package com.oreilly.jent.jndi;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import java.util.Properties;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NameClassPair;
import javax.naming.NamingEnumeration;

// A test utility that prints the contents of a given context within
// a specified JNDI server.  Useful for checking state of a JNDI server,
// without needing to use the NamingShell.
//
// Usage: java oreilly.jent.jndi.JNDIList <factoryClassname> <providerURL> 
//                                        <context>
//   e.g., > java oreilly.jent.jndi.JNDIList 
//             weblogic.jndi.WLInitialContextFactory t3://localhost:7001 
//             java:comp/env/jdbc
//
// Author: Jim Farley

public class JNDIList {
  public static void main(String[] args) {
    try {
      // Get a JNDI context from our J2EE server
      Properties props = new Properties();
      props.put(
        Context.INITIAL_CONTEXT_FACTORY,
        "weblogic.jndi.WLInitialContextFactory");
      props.put(Context.PROVIDER_URL, "t3://localhost:7011");

      Context context = new InitialContext(props);

      NamingEnumeration ctxEnum = context.list("");
      System.out.println("root context");
      while (ctxEnum.hasMore()) {
        NameClassPair p = (NameClassPair) ctxEnum.next();
        System.out.println(
          "name = " + p.getName() + ", class = " + p.getClassName());
      }
      System.out.println("Listing of context " + args[0]);
      ctxEnum = context.list(args[0]);
      while (ctxEnum.hasMore()) {
        NameClassPair p = (NameClassPair) ctxEnum.next();
        System.out.println(
          "name = " + p.getName() + ", class = " + p.getClassName());
      }
    }
    catch (Exception e) {
      System.out.println("Error while creating/using person");
      e.printStackTrace();
    }
  }
}
